from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('SIBWSSecurityResponseReceiverBindingConfig')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereSIBWSSecurityResponseReceiverBindingConfig");
  exportedObject.put("roleName", "WebSphereSIBWSSecurityResponseReceiverBindingConfig");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.sibwssecurityresponsereceiverbindingconfig.name", objid, "name","SIBWSSecurityResponseReceiverBindingConfig");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('SIBWSSecurityResponseReceiverBindingConfig');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('SIBWSSecurityResponseReceiverBindingConfig')
  if not jsonobject.has("roleProperties"):
    raise Exception("SIBWSSecurityResponseReceiverBindingConfig resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "name", roleProperties.optString("websphere.sibwssecurityresponsereceiverbindingconfig.name", None));
  print "Creating SIBWSSecurityResponseReceiverBindingConfig with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("SIBWSSecurityResponseReceiverBindingConfig", parentid, properties);
  Util.popPathElement('SIBWSSecurityResponseReceiverBindingConfig');

def update(objid,jsonobject):
  Util.pushPathElement('SIBWSSecurityResponseReceiverBindingConfig')
  if not jsonobject.has("roleProperties"):
    raise Exception("SIBWSSecurityResponseReceiverBindingConfig resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.sibwssecurityresponsereceiverbindingconfig.name", None), "name","SIBWSSecurityResponseReceiverBindingConfig");
  if len(atts) != 0:
    print "Modifying SIBWSSecurityResponseReceiverBindingConfig with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "SIBWSSecurityResponseReceiverBindingConfig configuration up to date.";

  Util.popPathElement('SIBWSSecurityResponseReceiverBindingConfig');
